<?php

class Plugin
{
	var $title;
	var $body;

	var $out;
	var $page;
	var $action;
	var $print;
	var $id;
	var $mode;

	function Init($title='')
	{
		$this->title=$title;
		$this->body='';

		$this->id=get_invar('id', 'request');
		$this->out=get_invar('out', 'request');
		$this->print=get_invar('print', 'request');
		$this->action=get_invar('action', 'request');
		$this->mode=get_invar('mode', 'request');
		$this->page=get_invar('page', 'request');

	}

	function display(){}
	function rss(){}
}

function print_one_line($file)
{
	$buf=print_afile($file);
	return $buf[0];
}

function add_css($file)
{
	global $css_main;
	$css_main[]=$file;
}

function add_java_script($file)
{
	global $java_scripts;
	$java_scripts[]=$file;
}

function add_plugin($data)
{
	global $plugins;
	$plugins[]=$data;
}

function make_sys_a($content, $r, $action='', $type='', $other='')
{
	$string='<a href="'.LINK_MAIN_R.$r;
	if (!empty($action))	$string.='&amp;action='.$action;
	if (!empty($type))	$string.='&amp;type='.$type;
	if (!empty($other))	$string.='&amp;'.$other;
	$string.='">'.$content.'</a>';

	return $string;
}

function true_link($link)
{
	$link=str_replace('&', '&amp;', $link);
	$link=str_replace('&amp;amp;', '&amp;', $link);

	return $link;
}

function is_flag($text, $flag)
{
	$text=trim($text);
	if (empty($text))	return false;
	$text='&'.$text.'&';
	$flag='&'.$flag.'&';
	if (strpos($text, $flag)!==false)	return true;

	return false;
}

function get_invar($name, $mas, $type='string')
{
	$buf='';

	switch($mas)
	{
		case 'get':
			if (isset($_GET[$name]))	$buf=$_GET[$name];
		break;
		case 'post':
			if (isset($_POST[$name]))	$buf=$_POST[$name];
		break;
		case 'request':
			if (isset($_REQUEST[$name]))	$buf=$_REQUEST[$name];
		break;
		case 'cookie':
			if (isset($_COOKIE[$name]))	$buf=$_COOKIE[$name];
		break;
	}

	if ($type=='string' and ini_get(magic_quotes_sybase))
	{
		$buf=stripslashes($buf);
	}
	settype($buf, $type);

	return $buf;
}

function savew($file, $text, $check=false)
{
	if ($check)
	{
		if (!file_exists($file)) return;
	}

	$F=fopen($file, 'w');
	if ($F)
	{
		flock($F, LOCK_EX);
		fwrite($F , $text);
		flock($F, LOCK_UN);
		fclose($F);
	}

	return;
}


function savea($file, $text, $check=false)
{
	if ($check)
	{
		if (!file_exists($file))	return false;
	}

	$F=fopen($file, 'a');
	if ($F)
	{
		flock($F, LOCK_EX);
		fwrite($F , $text);
		flock($F, LOCK_UN);
		fclose($F);
	}
	else	return false;

	return true;
}

function getmicrotime()
{
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}

function my_filemtime($file)
{
	if (file_exists($file))
	{
		return date('d.m.Y', filemtime($file));
	}
	return false;
}

function print_file($file)
{
	$string='';
	if (file_exists($file) and !is_dir($file))	$string=file_get_contents($file);

	return $string;
}

function print_afile($file, $trim=false)
{
	$array=array();
	if (file_exists($file) and !is_dir($file))	$array=file($file);

	if ($trim)
	{
		for($i=0; $i<count($array); $i++)	$array[$i]=trim($array[$i]);
	}


	return $array;
}

function print_arazfile($file)
{
	$string=print_afile($file);
	for($i=0; $i<count($string); $i++)	$string[$i]=explode(RAZ, $string[$i]);

	return $string;
}

function print_first_line($file)
{
	$buf=print_afile($file);

	return $buf[0];
}

function print_last_line($file)
{
	$buf=print_afile($file);
	$n=count($buf)-1;
	$text='';
	if ($n>=0)	$text=$buf[$n];

	return $text;
}

function count_file($file)
{
	return count(print_afile($file));
}

function no_cashe_headers()
{
	header('Cache-Control: no-cache');
	header('Pragma: no-cache');
	header('Last-Modified: '. gmdate("D, d M Y H:i:s") .' GMT');
}

function go_location($loc)
{
	no_cashe_headers();
	header('Location: '.$loc);

	exit();
}

function go_begin()
{
	go_location(LINK_MAIN);
}

function is_ban($type='ip', $file=TEXT_BAN_LIST)
{
	$pre=print_afile($file);
	$ip=$_SERVER['REMOTE_ADDR'];
	foreach($pre as $buf)
	{
		$buf=rtrim($buf);
		$len=strlen($buf);
		if (!empty($buf))
		{
			if (!strncmp($ip, $buf, $len)!==false)	return true;
		}
	}
	return false;
}

function is_cenz($text, $file=TEXT_CENZ)
{
	if (!empty($text))
	{
		$buf=print_afile($file);
		foreach ($buf as $str)
		{
			if (empty($str)) continue;
			if (stristr($text, rtrim($str))!==false)	return true;
		}
	}

	return false;
}

function smiles($string)
{
	$file_smiles=print_afile(TEXT_SMILES);
	foreach($file_smiles as $pre)
	{
		list($text, $img)=explode('@', rtrim($pre));
		$string=str_replace($text, $img, $string);
	}
	return $string;
}

function mail_spec($to, $from, $subject, $message, $sleep=true)
{
	if ($sleep)	sleep(SLEEP_TIME);
	global $prefs_main;

	$message=preg_replace('<img .*?>', '', $message);
	$message='<html><body>'.$message.'</body></html>';
	$message.='<p>- - -</p><p><a href="'.SITE_HTTP_NAME.'">'.SITE_WWW_NAME.'</a>
		<br /><a href="mailto:'.$prefs_main->getText('email_info').'">'.$prefs_main->getText('email_info').'</a></p>';

	$from_full='From: '.$from."\r\n".'Reply-To: '.EMAIL_INFO."\r\n";
	$from_full.='Content-type: text/html; charset="windows-1251"'."\r\n";
	$from_full.='X-Mailer: '.SITE_ENGINE;

	if (empty($to) or empty($message))	return $false;
	mail($to, $subject, $message, $from_full);

	/*print $subject."<br /><br />";
	print $message;
	exit();*/

	return true;
}

function my_time()
{
	$month=date('n');
	$wday=date('w');

	$mons=array("", "","","","","","","","","","","","");
	$dayweek=array("","","","","","","");
	return $dayweek[$wday].', '.date('j').' '.$mons[$month].date(' Y, H:i').'&nbsp;';
}

function mkLink($link)
{
	$string='&nbsp;&nbsp;<a href="'.$link['url'].$link['query'].'">'.$link['text'].'</a>';

	return $string;
}

function obrab_title($text)
{
	$text=trim($text);
	$text=strip_tags($text);
	$text=str_replace('"', '&quot;', $text);

	return $text;
}

function obrab_simple($string)
{
	$string=str_replace("\r", '', $string);

	$string=trim($string, "\x00..\x1F");
	$string=stripslashes($string);

	return $string;
}

function obrab_admin($string, $end=false)
{
	$string=str_replace("\r", '', $string);

	if ($end) $string=str_replace("\n", '[n]', $string);
	else $string=str_replace("\n", '', $string);

	$string=str_replace(RAZ, "[raz]", $string);
	$string=trim($string, "\x00..\x1F");
	$string=stripslashes($string);

	return $string;
}

function obrab($string, $end=false)
{
	$string=str_replace("\r", '', $string);
	$string=ereg_replace("\n{3,}","\n\n", $string);

	if ($end) $string=str_replace("\n", '[n]', $string);
	else $string=str_replace("\n", '', $string);

	$string=str_replace(RAZ, "[raz]", $string);
	$string=trim($string, "\x00..\x1F");

	$string=strip_tags($string);
	$string=htmlspecialchars($string);

	return $string;
}

function obrab_back($string)
{
	$string=str_replace('[n]', ' <br />', $string);
	$string=str_replace('[raz]', RAZ, $string);

	return $string;
}

function is_email($text)
{
	if (!eregi('^([a-z0-9_]|\\-|\\.)+'.'@'.'(([a-z0-9_]|\\-)+\\.)+'.'[a-z0-9]{2,4}$', $text))	return false;

	return true;
}

function delete_message($file, $id)
{
	if (file_exists($file))
	{
		$buf=print_afile($file);
		$text='';
		foreach($buf as $line)
		{
			list($id_time)=explode(RAZ, $line);
			if ($id==$id_time)	continue;
			else	$text.=$line;

		}

		savew($file, $text);
		return true;
	}

	return false;
}

function edit_message($file, $id, $new_line)
{
	if (file_exists($file))
	{
		$buf=print_afile($file);
		$text='';
		foreach($buf as $line)
		{
			list($id_time)=explode(RAZ, $line);
			if ($id==$id_time)	$text.=$new_line;
			else	$text.=$line;
		}

		savew($file, $text);
		return true;
	}

	return false;
}

function get_message($file, $id)
{
	if (file_exists($file))
	{
		$buf=print_afile($file);
		$text='';
		foreach($buf as $line)
		{
			list($id_time)=explode(RAZ, $line);
			if ($id==$id_time)	return $line;
		}
	}

	return false;
}


function html_upload_file($file)
{
	if (isset($_FILES['upload_file_html']))
	{
		if (!is_html())	go_thanks('html_error');
		if (!file_exists($file))
		{
			move_uploaded_file($_FILES['upload_file_html']['tmp_name'], $file);
			return true;
		}
		else	go_thanks('file_exists');
	}

	return false;
}

function is_html()
{
	$type=$_FILES['upload_file_html']['type'];

	if ($type=='text/html')	return true;

	return false;
}

function get_cat($dir, $ext='')
{
	$res=array();
	if (!empty($ext))	$ext='.'.$ext;

	if (file_exists($dir))
	{
		if ($dh=opendir($dir))
		{
			while (false !== ($file = readdir($dh)))
			{
				if ($file=='.' or $file=='..')	continue;
				if (!empty($ext))
				{
					$bext=substr($file, -4, 4);
					if ($bext!=$ext)	continue;
				}
				$res[]=$file;
			}
			closedir($dh);
		}
	}

	return $res;
}

function is_old_file($file, $timeout, $check_exists=true)
{
	if ($check_exists)
	{
		if (!file_exists($file))	return true;
	}

	$time=mktime()-filemtime($file);
	if ($time<$timeout)	return	false;

	return true;
}

function is_old_time($prev_time, $timeout)
{
	$time=mktime()-$prev_time;
	if ($time<$timeout)	return	false;

	return true;
}


function set_style($text, $array_tags)
{
	foreach($array_tags as $buf)
	{
		list($one, $two)=explode(RAZ, $buf);
		$text=str_replace($one, $two, $text);
	}
	$text=str_replace("[raz]", RAZ, $text);

	return $text;
}

function generate_pas()
{
	$pas=md5(uniqid(rand(),true));
	$pas=substr($pas, 0, LEN_PAS);

	return $pas;
}

function AddBackLink($align='right', $mini=true)
{
	if (get_invar('print', 'get'))	return;
	if ($mini)	$class=' class="small"';
	else	$class='';

	return '<p style="text-align:'.$align.'"'.$class.'><a href="javascript:history.go(-1);"></a></p>';
}

function AddPrintLink($nop=false)
{
/*	if (get_invar('print', 'get'))	return;
	$string='';
	if (!$nop)	$string.='<p style="text-align:right" class="small">';
	$string.='<img alt="  " style="width:16px; height:16px; border:0" src="gfx/smiles/print.gif" /> <a href="';


	$url=$_SERVER['REQUEST_URI'];
	if ($_SERVER['REQUEST_URI']!='')
	{
		if (empty($_SERVER['QUERY_STRING']))	$url.='?';
		else	$url.='&';
	}
	$url.='print=1';
	$url=str_replace('&', '&amp;', $url);
	$string.=$url.'" target="_blank">  </a>';
	if (!$nop)	$string.='</p>';

	return $string;*/
}

?>